use strict;
use BerkeleyDB;

sub get_caller_id
{
	my $file = shift;
	my $key = shift;
	my $ext = shift;
	my $server_id = shift;
	return undef unless $server_id =~ /^\d+$/;
	return undef unless $ext =~ /^\d+$/;
	my $offset = "317";

	# Configure password for AES encryption
	my $password=$server_id . $key . $offset;


	my $edb = new BerkeleyDB::Hash
	    -Filename   => $file,
	    -Flags      => 0,
	    -Encrypt    => { -Password => $password, Flags => DB_ENCRYPT_AES };

	if (!defined($edb))
	{
		die "Cannot open file $file: $! $BerkeleyDB::Error\n";
	}

	my $ret;
	# handles the DB timeout

	eval {
		# what to do in case of a timeout
	    local $SIG{ALRM} = sub { return undef; };
	    alarm(20);

	    my $data;
	    my $status = $edb->db_get ( pack ('l',$ext), $data );
	    if (!$status)
	    {
		my @cid = unpack ( "Z*Z*Z*", $data );
		if ( @cid )
		{
			$ret = $cid[0];
		}
	    }
	    undef $edb;
	    alarm(0);
	};
	alarm(0);

	return $ret;
}

1;
